const canoe = {};

canoe.GetCodeCompetition = function()
{
	if (typeof wsContext.notify_race === "object")
		return parseInt(wsContext.notify_race.Code_competition);
	else
		return 0;
}

canoe.GetCodeCourse = function()
{
	if (typeof wsContext.notify_race === "object")
		return parseInt(wsContext.notify_race.Code_course);
	else
		return 0;
}

canoe.GetCodePhase = function()
{
	if (typeof wsContext.notify_race === "object")
		return parseInt(wsContext.notify_race.Code_phase);
	else
		return 0;
}

canoe.GetCodeActivite = function()
{
	if (typeof wsContext.notify_race === "object")
	{
		const tCompetition = adv.GetTable(wsContext.notify_race, 'Competition');
		if (typeof tCompetition === "object")
			return tCompetition.GetCell('Code_activite', 0);
	}
	return '?';
}	

canoe.GetCodeNiveau = function()
{
	if (typeof wsContext.notify_race === "object")
	{
		const tCompetition = adv.GetTable(wsContext.notify_race, 'Competition');
		if (typeof tCompetition === "object")
			return tCompetition.GetCell('Code_niveau', 0);
	}
	return '?';
}	

canoe.GetCodeCoursePhase = function()
{
	return canoe.GetCodeCourse().toString()+'_'+canoe.GetCodePhase().toString();
}

canoe.GetNbInter = function()
{
	if (typeof wsContext.notify_race === "object")
		return parseInt(wsContext.notify_race.Nb_inter);
	else
		return 0;
}

canoe.GetNbSecteur = function()
{
	if (typeof wsContext.notify_ranking === "object" && typeof wsContext.notify_ranking.Secteur == "object")
		return wsContext.notify_ranking.Secteur.length;
	else
		return 0;
}

canoe.GetPorteMin = function(secteur)
{
	if (typeof wsContext.notify_ranking === "object" && typeof wsContext.notify_ranking.Secteur == "object")
	{
		let p = 0;
		for (let s=0;s<secteur-1;s++)
			p += wsContext.notify_ranking.Secteur[s];
		
		return p+1;
	}
	else
		return 0;
}

canoe.GetPorteMax = function(secteur)
{
	if (typeof wsContext.notify_ranking === "object" && typeof wsContext.notify_ranking.Secteur == "object")
	{
		let p = 0;
		for (let s=0;s<secteur-1;s++)
			p += wsContext.notify_ranking.Secteur[s];
		
		return p+wsContext.notify_ranking.Secteur[secteur-1];
	}
	else
		return 0;
}

canoe.GetNbPorte = function(secteur)
{
	return canoe.GetPorteMax(secteur) - canoe.GetPorteMin(secteur) + 1;
}

canoe.GetNbPorteInv = function()
{
	if (typeof wsContext.notify_ranking === "object" && typeof wsContext.notify_ranking.Porte_inverse == "object")
		return wsContext.notify_ranking.Porte_inverse.length;
	else
		return 0;
}

canoe.IsPorteInv = function(porte)
{
	if (typeof wsContext.notify_ranking === "object" && typeof wsContext.notify_ranking.Porte_inverse == "object")
	{
		for (let p = 0; p < wsContext.notify_ranking.Porte_inverse.length; p++)
		{
			if (wsContext.notify_ranking.Porte_inverse[p] == porte)
				return true;
		}
	}
	
	return false;
}

canoe.SetColumnNameRanking = function(tRanking)
{
	if (canoe.GetCodeActivite() == 'SLA')
	{
		const course_phase = canoe.GetCodeCoursePhase();

		tRanking.SetColumnName('@RK_'+course_phase+'_1', 'Cltc'+course_phase);
		tRanking.SetColumnName('@START_TIME_'+course_phase+'_1', 'Heure_depart'+course_phase);
		tRanking.SetColumnName('@CHRONO_'+course_phase+'_1', 'Tps_chrono'+course_phase);
		tRanking.SetColumnName('@TIME_'+course_phase+'_1', 'Tps'+course_phase);
		
		const nbPorte = wsContext.notify_ranking.Nb_porte;
		for (let p = 1; p <= nbPorte; p++)
			tRanking.SetColumnName('@PENA_'+p.toString()+'_1', "Pena_"+p.toString());

		tRanking.SetColumnName('@SUMPENA_'+course_phase+'_1', 'Total_pena'+course_phase);
		
		if (tRanking.GetIndexColumn("@CHRONO_INTER1_"+course_phase+'_1') >= 0)
		{
			tRanking.SetColumnName('@CHRONO_INTER1_'+course_phase+'_1', 'Tps'+course_phase+'_inter1');
			tRanking.SetColumnName('@RK_INTER1_'+course_phase+'_1', 'Cltc'+course_phase+'_inter1');
		}
		
		if (tRanking.GetIndexColumn("@CHRONO_INTER2_"+course_phase+'_1') >= 0)
		{
			tRanking.SetColumnName('@CHRONO_INTER2_'+course_phase+'_1', 'Tps'+course_phase+'_inter2');
			tRanking.SetColumnName('@RK_INTER2_'+course_phase+'_1', 'Cltc'+course_phase+'_inter2');
		}
	}
}

canoe.UpdateSlalomPena = function(tRanking, row, porte, pena)
{
	tRanking.SetCell('Pena_'+porte, row, pena);
	return canoe.UpdateSlalomFinishTime(tRanking, row);
}

canoe.GetCurrentSlalomTotalPena = function(tRanking, row)
{
	const course_phase = canoe.GetCodeCoursePhase();
	const nb_porte = wsContext.notify_ranking.Nb_porte;

	var sumPena = 0;
	for (let p = 1; p <= nb_porte; p++)
	{
		var pen = tRanking.GetCell('Pena_'+p.toString(), row);
		if (pen == '2')
			sumPena += 2;
		else if (pen == '50')
			sumPena += 50;
	}
	
	return sumPena;
}

canoe.GetCurrentSlalomCountPena = function(tRanking, row)
{
	const course_phase = canoe.GetCodeCoursePhase();
	const nb_porte = wsContext.notify_ranking.Nb_porte;

	var count = 0;
	for (let p = 1; p <= nb_porte; p++)
	{
		var pen = tRanking.GetCell('Pena_'+p.toString(), row);
		if (pen == '2' || pen == '50' || pen == '0')
			++count;
	}
	
	return count;
}

canoe.UpdateSlalomTotalPena = function(tRanking, row)
{
	const course_phase = canoe.GetCodeCoursePhase();
	const nb_porte = wsContext.notify_ranking.Nb_porte;

	var sumPena = 0;
	for (let p = 1; p <= nb_porte; p++)
	{
		var pen = tRanking.GetCell('Pena_'+p.toString(), row);
		if (pen == '2')
			sumPena += 2;
		else if (pen == '50')
			sumPena += 50;
		else if (pen != '0')
		{
			sumPena = -1;
			break;
		}
	}
	
	tRanking.SetCell('Total_pena'+course_phase, row, sumPena);
	return sumPena;
}

canoe.UpdateSlalomFinishTime = function(tRanking, row)
{
	const course_phase = canoe.GetCodeCoursePhase();

	var newTps = adv.chrono.KO;
	var sumPena = canoe.UpdateSlalomTotalPena(tRanking, row);
	if (sumPena >= 0)
	{
		var tpsChrono = tRanking.GetCellInt('Tps_chrono'+course_phase, row);
		if (tpsChrono >= adv.chrono.OK)
			newTps = tpsChrono + sumPena * 1000;
		else
			newTps = tpsChrono;
	}

//	alert('UpdateSlalomFinishTime tps='+newTps+' sum='+sumPena);
	
	const oldTps = tRanking.GetCellInt('Tps'+course_phase, row);
	if (oldTps != newTps)
	{
		tRanking.UpdateRankingTime(row, tRanking.GetIndexColumn('Tps'+course_phase), tRanking.GetIndexColumn('Cltc'+course_phase), oldTps, newTps);
	}
	
	return newTps;
}

